unit Faxform1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DdeMan, StdCtrls, ExtCtrls, Menus;

type
  TfaxForm = class(TForm)
    DDEClient1: TDdeClientConv;
    DdeClientItem1: TDdeClientItem;
    Panel1: TPanel;
    btnSend: TButton;
    btnClose: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Memo1: TMemo;
    CheckBox1: TCheckBox;
    Panel2: TPanel;
    btnStatus: TButton;
    Label3: TLabel;
    Label4: TLabel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Send1: TMenuItem;
    Status1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    FaxWindow1: TMenuItem;
    Display1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    procedure btnSendClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnStatusClick(Sender: TObject);
    procedure DDEClient1Close(Sender: TObject);
    procedure DDEClient1Open(Sender: TObject);
    procedure Send1Click(Sender: TObject);
    procedure Status1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Display1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  faxForm: TfaxForm;
  ConnectionEstablished: Boolean;

type
  { My own little Exception for this thing }
  EBadDDEPoke = class(Exception);

implementation

uses
  About1;

{$R *.DFM}

procedure TfaxForm.btnSendClick(Sender: TObject);
var
  { gotta have it big for the Text Message }
  pCommand, pText: array [0..4095] of char;
  pTemp: array [0..80] of char;
  n: word;
begin
  { No point in continuing if the connection wasn't made }
  If ConnectionEstablished then
    begin
      { DDEClientItem may not be necessary }
      DDEClientItem1.DDEConv := DDEClient1;
      DDEClientItem1.DDEItem := 'Sendfax';
      { This parameter set up the Name and Phone Number of Fax Recipient }
      StrPCopy(pCommand,'recipient("'+Edit2.Text+'",,,"'+Edit1.Text+'",,,"Fax")');
      try
        { Must use literal 'Sendfax'  as opposed to DDEClientItem.DDEItem
          as the 1st parameter of the PokeData method }
        If DDEClient1.PokeData('Sendfax',pCommand) = False then
          raise EBadDDEPoke.Create('Poke of ' + StrPas(pCommand) + ' failed');
        If Memo1.Lines.Count > 0 then
          for n := 0 to Memo1.Lines.Count - 1 do
            StrCat(pText,StrPCopy(pTemp,Memo1.Lines[n]+Chr(10)+Chr(13)));
        { You could clean up my string handling here if you want to
          what you want to end up with is something like this:
          'fillcoverpage("Your text lines up to 4095 characters here")'  }
        StrPCopy(pCommand,'fillcoverpage("');
        StrPCopy(pTemp,'")');
        StrCat(pCommand,pText);
        StrCat(pCommand,pTemp);
        If DDEClient1.PokeData('Sendfax',pCommand)= False then
          raise EBadDDEPoke.Create('Poke of fillcoverpage failed');
        { This will show the Send Screen if checked }
        If CheckBox1.Checked Then
          StrPCopy(pCommand,'showsendscreen("1")')
        else
          StrPCopy(pCommand,'showsendscreen("0")');
        If DDEClient1.PokeData('Sendfax',pCommand)= False then
          raise EBadDDEPoke.Create('Poke of ' + StrPas(pCommand) + ' failed');
        { I'm not sure if this is really needed or not }
        StrPCopy(pCommand,'sendfaxui');
        DDEClient1.ExecuteMacro(pCommand,False);
      finally
        { Make sure that you close the DDE link }
        DDEClient1.CloseLink;
        btnSend.Enabled := False;
        Send1.Enabled := False;
      end;
    end;
end;

procedure TfaxForm.btnCloseClick(Sender: TObject);
begin
  If ConnectionEstablished then
      DDEClient1.CloseLink;
  Close;
end;

procedure TfaxForm.Edit1Change(Sender: TObject);
begin
  { Don't enable the Send button if there is no Name and Phone Number }
  If ((Edit1.Text <> '') and (Edit2.Text <> '')) then
    begin
      btnSend.Enabled := True;
      Send1.Enabled := True;
    end
  else
    begin
      btnSend.Enabled := False;
      Send1.Enabled := False;
    end;
end;

procedure TfaxForm.FormCreate(Sender: TObject);
begin
  Panel2.Caption := ' DDEConnection Closed';
 { TDDEClientConv }
  ConnectionEstablished := False;
  DDEClient1.DDEService := 'FAXMNG';
  DDEClient1.DDETopic := 'CONTROL';
  { Filter out the Control Characters }
  DDEClient1.FormatChars := True;
  { Check to see id ConnectMode is Automatic or Manual
    if Automatic, use SetLink - if Manual, use OpenLink }
  If DDEClient1.ConnectMode = ddeAutomatic then
    begin
      If DDEClient1.SetLink('FAXMNG','CONTROL') = False then
        MessageDlg('Unable to establish DDE link via SetLink',mtError,[mbOk],0);
    end
  else
    If DDEClient1.OpenLink = False then
      MessageDlg('Unable to establish DDE link via OpenLink',mtError,[mbOk],0);
end;

procedure TfaxForm.btnStatusClick(Sender: TObject);
var
  myStatus: pChar;
  sStatus: string;
begin
  myStatus := StrAlloc(20);
  { WinFax seems to return a #13#10 with the status
    so I decided to just use the first 4 characters.
    Supposedly using the FormatChars method takes care
    of this but it doesn't seem to work in this instance }
  StrLCopy(myStatus,DDEClient1.RequestData('Status'),4);
  If StrComp(myStatus,'BUSY') = 0 then
    sStatus := 'WinFax is currently busy sending or receiving';
  If StrComp(myStatus,'IDLE') = 0 then
    sStatus := 'WinFax is not monitoring incoming calls';
  If StrComp(myStatus,'ACTI') = 0 then
    sStatus := 'WinFax enabled but no fax event is in progress';
  If StrComp(myStatus,'REQU') = 0 then
    sStatus := 'WinFax is waiting to send a pending fax';
  MessageDlg(sStatus,mtInformation,[mbOk],0);
  { Don't forget to free up that allocated memory }
  StrDispose(myStatus);
end;

procedure TfaxForm.DDEClient1Close(Sender: TObject);
begin
  ConnectionEstablished := False;
  Panel2.Caption := ' DDEConnection Closed';
  btnStatus.Enabled := False;
  Status1.Enabled := False;
end;

procedure TfaxForm.DDEClient1Open(Sender: TObject);
begin
  ConnectionEstablished := True;
  Panel2.Caption := ' DDEConnection Active';
  btnStatus.Enabled := True;
  Status1.Enabled := True;
end;

procedure TfaxForm.Send1Click(Sender: TObject);
begin
  { Do the same thing as the button }
  btnSendClick(self);
end;

procedure TfaxForm.Status1Click(Sender: TObject);
begin
  { Do the same thing as the button }
  btnStatusClick(self);
end;

procedure TfaxForm.Exit1Click(Sender: TObject);
begin
  btnCloseClick(self);
end;

procedure TfaxForm.Display1Click(Sender: TObject);
begin
  { toggle the menu checkmark and set checkbox }
  Display1.Checked := not Display1.Checked;
  CheckBox1.Checked := Display1.Checked;
end;

procedure TfaxForm.CheckBox1Click(Sender: TObject);
begin
  { set menu checkmark }
  Display1.Checked := CheckBox1.Checked;
end;

procedure TfaxForm.About1Click(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

end.
